# -*- coding: utf-8 -*-
"""
DO NOT EDIT! This file is auto-generated

Classes for SystemLink Message Bus usage.
"""
from __future__ import absolute_import

# Import python libs
import json
import sys
from datetime import datetime  # pylint: disable=unused-import

# Import local libs
# pylint: disable=import-error
from systemlink.messagebus.broadcast_message import BroadcastMessage  # pylint: disable=unused-import
from systemlink.messagebus.datetime import from_datetime, to_datetime  # pylint: disable=unused-import
from systemlink.messagebus.message_header import (  # pylint: disable=unused-import
    MessageHeader, JSON_MESSAGE_CONTENT_TYPE, BINARY_MESSAGE_CONTENT_TYPE)
from systemlink.messagebus.message_base import MessageBase
from systemlink.messagebus.request_message import RequestMessage  # pylint: disable=unused-import
from systemlink.messagebus.response_message import ResponseMessage  # pylint: disable=unused-import
from systemlink.messagebus.routed_message import RoutedMessage  # pylint: disable=unused-import
# pylint: enable=import-error

if sys.version_info[0] >= 3:
    long = int  # pylint: disable=redefined-builtin,invalid-name


# pylint: disable=line-too-long,too-many-lines,too-many-instance-attributes,too-many-arguments,too-many-locals


#
# AssetPerformanceManagementMessageObjects namespace
#


class QueryOperator(object):  # pylint: disable=too-few-public-methods
    """
    QueryOperator normal enum.
    """
    CONTAINS = 0
    NOT_CONTAINS = 1
    EQUAL = 2
    NOT_EQUAL = 3
    LESS_THAN = 4
    GREATER_THAN = 5
    LESS_THAN_OR_EQUAL = 6
    GREATER_THAN_OR_EQUAL = 7
    _INT_TO_STRING = {
        0: 'CONTAINS',
        1: 'NOT_CONTAINS',
        2: 'EQUAL',
        3: 'NOT_EQUAL',
        4: 'LESS_THAN',
        5: 'GREATER_THAN',
        6: 'LESS_THAN_OR_EQUAL',
        7: 'GREATER_THAN_OR_EQUAL'
    }
    _STRING_TO_INT = {
        'CONTAINS': 0,
        'NOT_CONTAINS': 1,
        'EQUAL': 2,
        'NOT_EQUAL': 3,
        'LESS_THAN': 4,
        'GREATER_THAN': 5,
        'LESS_THAN_OR_EQUAL': 6,
        'GREATER_THAN_OR_EQUAL': 7
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`QueryOperator` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`QueryOperator`.
        :rtype: QueryOperator
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class SystemConnectionState(object):  # pylint: disable=too-few-public-methods
    """
    SystemConnectionState normal enum.
    """
    APPROVED = 0
    DISCONNECTED = 1
    CONNECTED_UPDATE_PENDING = 2
    CONNECTED_UPDATE_SUCCESSFUL = 3
    CONNECTED_UPDATE_FAILED = 4
    UNSUPPORTED = 5
    ACTIVATED = 6
    _INT_TO_STRING = {
        0: 'APPROVED',
        1: 'DISCONNECTED',
        2: 'CONNECTED_UPDATE_PENDING',
        3: 'CONNECTED_UPDATE_SUCCESSFUL',
        4: 'CONNECTED_UPDATE_FAILED',
        5: 'UNSUPPORTED',
        6: 'ACTIVATED'
    }
    _STRING_TO_INT = {
        'APPROVED': 0,
        'DISCONNECTED': 1,
        'CONNECTED_UPDATE_PENDING': 2,
        'CONNECTED_UPDATE_SUCCESSFUL': 3,
        'CONNECTED_UPDATE_FAILED': 4,
        'UNSUPPORTED': 5,
        'ACTIVATED': 6
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`SystemConnectionState` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`SystemConnectionState`.
        :rtype: SystemConnectionState
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class AssetPresenceStatus(object):  # pylint: disable=too-few-public-methods
    """
    AssetPresenceStatus normal enum.
    """
    INITIALIZING = -2
    UNKNOWN = -1
    NOT_PRESENT = 0
    PRESENT = 1
    _INT_TO_STRING = {
        -2: 'INITIALIZING',
        -1: 'UNKNOWN',
        0: 'NOT_PRESENT',
        1: 'PRESENT'
    }
    _STRING_TO_INT = {
        'INITIALIZING': -2,
        'UNKNOWN': -1,
        'NOT_PRESENT': 0,
        'PRESENT': 1
    }

    def __init__(self, value):
        """
        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @property
    def value(self):
        """
        Get integer value of the enum.

        :return: The integer value of the enum.
        :rtype: int
        """
        return self._value

    @value.setter
    def value(self, value):
        """
        Set integer value of the enum.

        :param value: The integer value of the enum.
        :type value: int
        """
        self._value = value

    @classmethod
    def from_string(cls, value_string):
        """
        Create a new instance of :class:`AssetPresenceStatus` using a string.

        :param value_string: The string value of the enum.
        :type value_string: str
        :return: A new instance of :class:`AssetPresenceStatus`.
        :rtype: AssetPresenceStatus
        """
        value = cls._STRING_TO_INT[value_string]
        return cls(value)

    def to_string(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self._INT_TO_STRING[self._value]

    def __str__(self):
        """
        Returns a string representing the enum.

        :return: A string representing the enum.
        :rtype: str
        """
        return self.to_string()


class StringQueryEntry(object):
    """
    StringQueryEntry custom data type.
    """
    def __init__(self,
                 key_,
                 value_,
                 operation_):
        """
        :param key_: key
        :type key_: str
        :param value_: value
        :type value_: str
        :param operation_: operation
        :type operation_: QueryOperator
        """
        self.key = key_
        self.value = value_
        self.operation = operation_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`StringQueryEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`StringQueryEntry`.
        :rtype: StringQueryEntry
        """
        key_ = body_dict.get('key')
        value_ = body_dict.get('value')
        operation_ = body_dict.get('operation')
        if operation_ is not None:
            if isinstance(operation_, str):
                operation_ = QueryOperator.from_string(operation_)
            elif isinstance(operation_, int):
                operation_ = QueryOperator(operation_)
        return cls(
            key_=key_,
            value_=value_,
            operation_=operation_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`StringQueryEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`StringQueryEntry`.
        :rtype: StringQueryEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`StringQueryEntry` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`StringQueryEntry`.
        :rtype: StringQueryEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        key_ = self.key
        value_ = self.value
        operation_ = self.operation
        if operation_ is not None:
            operation_ = operation_.to_string()
        return {
            'key': key_,
            'value': value_,
            'operation': operation_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class IntQueryEntry(object):
    """
    IntQueryEntry custom data type.
    """
    def __init__(self,
                 key_,
                 value_,
                 operation_):
        """
        :param key_: key
        :type key_: str
        :param value_: value
        :type value_: int
        :param operation_: operation
        :type operation_: QueryOperator
        """
        self.key = key_
        self.value = value_
        self.operation = operation_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`IntQueryEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`IntQueryEntry`.
        :rtype: IntQueryEntry
        """
        key_ = body_dict.get('key')
        value_ = body_dict.get('value')
        operation_ = body_dict.get('operation')
        if operation_ is not None:
            if isinstance(operation_, str):
                operation_ = QueryOperator.from_string(operation_)
            elif isinstance(operation_, int):
                operation_ = QueryOperator(operation_)
        return cls(
            key_=key_,
            value_=value_,
            operation_=operation_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`IntQueryEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`IntQueryEntry`.
        :rtype: IntQueryEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`IntQueryEntry` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`IntQueryEntry`.
        :rtype: IntQueryEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        key_ = self.key
        value_ = self.value
        operation_ = self.operation
        if operation_ is not None:
            operation_ = operation_.to_string()
        return {
            'key': key_,
            'value': value_,
            'operation': operation_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class LongQueryEntry(object):
    """
    LongQueryEntry custom data type.
    """
    def __init__(self,
                 key_,
                 value_,
                 operation_):
        """
        :param key_: key
        :type key_: str
        :param value_: value
        :type value_: long
        :param operation_: operation
        :type operation_: QueryOperator
        """
        self.key = key_
        self.value = value_
        self.operation = operation_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`LongQueryEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`LongQueryEntry`.
        :rtype: LongQueryEntry
        """
        key_ = body_dict.get('key')
        value_ = body_dict.get('value')
        operation_ = body_dict.get('operation')
        if operation_ is not None:
            if isinstance(operation_, str):
                operation_ = QueryOperator.from_string(operation_)
            elif isinstance(operation_, int):
                operation_ = QueryOperator(operation_)
        return cls(
            key_=key_,
            value_=value_,
            operation_=operation_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`LongQueryEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`LongQueryEntry`.
        :rtype: LongQueryEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`LongQueryEntry` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`LongQueryEntry`.
        :rtype: LongQueryEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        key_ = self.key
        value_ = self.value
        operation_ = self.operation
        if operation_ is not None:
            operation_ = operation_.to_string()
        return {
            'key': key_,
            'value': value_,
            'operation': operation_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class DateQueryEntry(object):
    """
    DateQueryEntry custom data type.
    """
    def __init__(self,
                 key_,
                 value_,
                 operation_):
        """
        :param key_: key
        :type key_: str
        :param value_: value
        :type value_: datetime
        :param operation_: operation
        :type operation_: QueryOperator
        """
        self.key = key_
        self.value = value_
        self.operation = operation_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`DateQueryEntry` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`DateQueryEntry`.
        :rtype: DateQueryEntry
        """
        key_ = body_dict.get('key')
        value_ = body_dict.get('value')
        if value_ is not None and not isinstance(value_, datetime):
            value_ = to_datetime(value_)
        operation_ = body_dict.get('operation')
        if operation_ is not None:
            if isinstance(operation_, str):
                operation_ = QueryOperator.from_string(operation_)
            elif isinstance(operation_, int):
                operation_ = QueryOperator(operation_)
        return cls(
            key_=key_,
            value_=value_,
            operation_=operation_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`DateQueryEntry` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`DateQueryEntry`.
        :rtype: DateQueryEntry
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`DateQueryEntry` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`DateQueryEntry`.
        :rtype: DateQueryEntry
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        key_ = self.key
        value_ = self.value
        if value_ is not None and isinstance(value_, datetime):
            value_ = from_datetime(value_)
        operation_ = self.operation
        if operation_ is not None:
            operation_ = operation_.to_string()
        return {
            'key': key_,
            'value': value_,
            'operation': operation_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class SystemConnectionQuery(object):
    """
    SystemConnectionQuery custom data type.
    """
    def __init__(self,
                 key_,
                 value_,
                 operation_):
        """
        :param key_: key
        :type key_: str
        :param value_: value
        :type value_: SystemConnectionState
        :param operation_: operation
        :type operation_: QueryOperator
        """
        self.key = key_
        self.value = value_
        self.operation = operation_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SystemConnectionQuery` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SystemConnectionQuery`.
        :rtype: SystemConnectionQuery
        """
        key_ = body_dict.get('key')
        value_ = body_dict.get('value')
        if value_ is not None:
            if isinstance(value_, str):
                value_ = SystemConnectionState.from_string(value_)
            elif isinstance(value_, int):
                value_ = SystemConnectionState(value_)
        operation_ = body_dict.get('operation')
        if operation_ is not None:
            if isinstance(operation_, str):
                operation_ = QueryOperator.from_string(operation_)
            elif isinstance(operation_, int):
                operation_ = QueryOperator(operation_)
        return cls(
            key_=key_,
            value_=value_,
            operation_=operation_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SystemConnectionQuery` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SystemConnectionQuery`.
        :rtype: SystemConnectionQuery
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SystemConnectionQuery` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`SystemConnectionQuery`.
        :rtype: SystemConnectionQuery
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        key_ = self.key
        value_ = self.value
        if value_ is not None:
            value_ = value_.to_string()
        operation_ = self.operation
        if operation_ is not None:
            operation_ = operation_.to_string()
        return {
            'key': key_,
            'value': value_,
            'operation': operation_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AssetPresenceQuery(object):
    """
    AssetPresenceQuery custom data type.
    """
    def __init__(self,
                 key_,
                 value_,
                 operation_):
        """
        :param key_: key
        :type key_: str
        :param value_: value
        :type value_: AssetPresenceStatus
        :param operation_: operation
        :type operation_: QueryOperator
        """
        self.key = key_
        self.value = value_
        self.operation = operation_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AssetPresenceQuery` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AssetPresenceQuery`.
        :rtype: AssetPresenceQuery
        """
        key_ = body_dict.get('key')
        value_ = body_dict.get('value')
        if value_ is not None:
            if isinstance(value_, str):
                value_ = AssetPresenceStatus.from_string(value_)
            elif isinstance(value_, int):
                value_ = AssetPresenceStatus(value_)
        operation_ = body_dict.get('operation')
        if operation_ is not None:
            if isinstance(operation_, str):
                operation_ = QueryOperator.from_string(operation_)
            elif isinstance(operation_, int):
                operation_ = QueryOperator(operation_)
        return cls(
            key_=key_,
            value_=value_,
            operation_=operation_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AssetPresenceQuery` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AssetPresenceQuery`.
        :rtype: AssetPresenceQuery
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AssetPresenceQuery` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`AssetPresenceQuery`.
        :rtype: AssetPresenceQuery
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        key_ = self.key
        value_ = self.value
        if value_ is not None:
            value_ = value_.to_string()
        operation_ = self.operation
        if operation_ is not None:
            operation_ = operation_.to_string()
        return {
            'key': key_,
            'value': value_,
            'operation': operation_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class PropertyProjection(object):
    """
    PropertyProjection custom data type.
    """
    def __init__(self,
                 properties_):
        """
        :param properties_: properties
        :type properties_: dict(str, bool)
        """
        self.properties = properties_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`PropertyProjection` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`PropertyProjection`.
        :rtype: PropertyProjection
        """
        properties_ = body_dict.get('properties')
        return cls(
            properties_=properties_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`PropertyProjection` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`PropertyProjection`.
        :rtype: PropertyProjection
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`PropertyProjection` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`PropertyProjection`.
        :rtype: PropertyProjection
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        properties_ = self.properties
        return {
            'properties': properties_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class QueryAssetsFilter(object):
    """
    QueryAssetsFilter custom data type.
    """
    def __init__(self,
                 serial_number_query_,
                 model_name_query_,
                 vendor_name_query_,
                 name_query_,
                 firmware_version_query_,
                 hardware_version_query_,
                 visa_resource_name_query_,
                 system_name_query_,
                 model_number_query_,
                 vendor_number_query_,
                 slot_number_query_,
                 last_self_calibration_date_query_,
                 last_external_calibration_date_query_,
                 next_recommended_calibration_date_query_,
                 last_updated_timestamp_query_,
                 system_connection_query_,
                 asset_presence_query_):
        """
        :param serial_number_query_: serial_number_query
        :type serial_number_query_: StringQueryEntry
        :param model_name_query_: model_name_query
        :type model_name_query_: StringQueryEntry
        :param vendor_name_query_: vendor_name_query
        :type vendor_name_query_: StringQueryEntry
        :param name_query_: name_query
        :type name_query_: StringQueryEntry
        :param firmware_version_query_: firmware_version_query
        :type firmware_version_query_: StringQueryEntry
        :param hardware_version_query_: hardware_version_query
        :type hardware_version_query_: StringQueryEntry
        :param visa_resource_name_query_: visa_resource_name_query
        :type visa_resource_name_query_: StringQueryEntry
        :param system_name_query_: system_name_query
        :type system_name_query_: StringQueryEntry
        :param model_number_query_: model_number_query
        :type model_number_query_: LongQueryEntry
        :param vendor_number_query_: vendor_number_query
        :type vendor_number_query_: LongQueryEntry
        :param slot_number_query_: slot_number_query
        :type slot_number_query_: IntQueryEntry
        :param last_self_calibration_date_query_: last_self_calibration_date_query
        :type last_self_calibration_date_query_: DateQueryEntry
        :param last_external_calibration_date_query_: last_external_calibration_date_query
        :type last_external_calibration_date_query_: DateQueryEntry
        :param next_recommended_calibration_date_query_: next_recommended_calibration_date_query
        :type next_recommended_calibration_date_query_: DateQueryEntry
        :param last_updated_timestamp_query_: last_updated_timestamp_query
        :type last_updated_timestamp_query_: DateQueryEntry
        :param system_connection_query_: system_connection_query
        :type system_connection_query_: SystemConnectionQuery
        :param asset_presence_query_: asset_presence_query
        :type asset_presence_query_: AssetPresenceQuery
        """
        self.serial_number_query = serial_number_query_
        self.model_name_query = model_name_query_
        self.vendor_name_query = vendor_name_query_
        self.name_query = name_query_
        self.firmware_version_query = firmware_version_query_
        self.hardware_version_query = hardware_version_query_
        self.visa_resource_name_query = visa_resource_name_query_
        self.system_name_query = system_name_query_
        self.model_number_query = model_number_query_
        self.vendor_number_query = vendor_number_query_
        self.slot_number_query = slot_number_query_
        self.last_self_calibration_date_query = last_self_calibration_date_query_  # pylint: disable=invalid-name
        self.last_external_calibration_date_query = last_external_calibration_date_query_  # pylint: disable=invalid-name
        self.next_recommended_calibration_date_query = next_recommended_calibration_date_query_  # pylint: disable=invalid-name
        self.last_updated_timestamp_query = last_updated_timestamp_query_
        self.system_connection_query = system_connection_query_
        self.asset_presence_query = asset_presence_query_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`QueryAssetsFilter` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`QueryAssetsFilter`.
        :rtype: QueryAssetsFilter
        """
        serial_number_query_ = body_dict.get('SerialNumberQuery')
        if serial_number_query_ is not None:
            serial_number_query_ = StringQueryEntry.from_dict(serial_number_query_)
        model_name_query_ = body_dict.get('ModelNameQuery')
        if model_name_query_ is not None:
            model_name_query_ = StringQueryEntry.from_dict(model_name_query_)
        vendor_name_query_ = body_dict.get('VendorNameQuery')
        if vendor_name_query_ is not None:
            vendor_name_query_ = StringQueryEntry.from_dict(vendor_name_query_)
        name_query_ = body_dict.get('NameQuery')
        if name_query_ is not None:
            name_query_ = StringQueryEntry.from_dict(name_query_)
        firmware_version_query_ = body_dict.get('FirmwareVersionQuery')
        if firmware_version_query_ is not None:
            firmware_version_query_ = StringQueryEntry.from_dict(firmware_version_query_)
        hardware_version_query_ = body_dict.get('HardwareVersionQuery')
        if hardware_version_query_ is not None:
            hardware_version_query_ = StringQueryEntry.from_dict(hardware_version_query_)
        visa_resource_name_query_ = body_dict.get('VisaResourceNameQuery')
        if visa_resource_name_query_ is not None:
            visa_resource_name_query_ = StringQueryEntry.from_dict(visa_resource_name_query_)
        system_name_query_ = body_dict.get('SystemNameQuery')
        if system_name_query_ is not None:
            system_name_query_ = StringQueryEntry.from_dict(system_name_query_)
        model_number_query_ = body_dict.get('ModelNumberQuery')
        if model_number_query_ is not None:
            model_number_query_ = LongQueryEntry.from_dict(model_number_query_)
        vendor_number_query_ = body_dict.get('VendorNumberQuery')
        if vendor_number_query_ is not None:
            vendor_number_query_ = LongQueryEntry.from_dict(vendor_number_query_)
        slot_number_query_ = body_dict.get('SlotNumberQuery')
        if slot_number_query_ is not None:
            slot_number_query_ = IntQueryEntry.from_dict(slot_number_query_)
        last_self_calibration_date_query_ = body_dict.get('LastSelfCalibrationDateQuery')  # pylint: disable=invalid-name
        if last_self_calibration_date_query_ is not None:
            last_self_calibration_date_query_ = DateQueryEntry.from_dict(last_self_calibration_date_query_)  # pylint: disable=invalid-name
        last_external_calibration_date_query_ = body_dict.get('LastExternalCalibrationDateQuery')  # pylint: disable=invalid-name
        if last_external_calibration_date_query_ is not None:
            last_external_calibration_date_query_ = DateQueryEntry.from_dict(last_external_calibration_date_query_)  # pylint: disable=invalid-name
        next_recommended_calibration_date_query_ = body_dict.get('NextRecommendedCalibrationDateQuery')  # pylint: disable=invalid-name
        if next_recommended_calibration_date_query_ is not None:
            next_recommended_calibration_date_query_ = DateQueryEntry.from_dict(next_recommended_calibration_date_query_)  # pylint: disable=invalid-name
        last_updated_timestamp_query_ = body_dict.get('LastUpdatedTimestampQuery')
        if last_updated_timestamp_query_ is not None:
            last_updated_timestamp_query_ = DateQueryEntry.from_dict(last_updated_timestamp_query_)
        system_connection_query_ = body_dict.get('SystemConnectionQuery')
        if system_connection_query_ is not None:
            system_connection_query_ = SystemConnectionQuery.from_dict(system_connection_query_)
        asset_presence_query_ = body_dict.get('AssetPresenceQuery')
        if asset_presence_query_ is not None:
            asset_presence_query_ = AssetPresenceQuery.from_dict(asset_presence_query_)
        return cls(
            serial_number_query_=serial_number_query_,
            model_name_query_=model_name_query_,
            vendor_name_query_=vendor_name_query_,
            name_query_=name_query_,
            firmware_version_query_=firmware_version_query_,
            hardware_version_query_=hardware_version_query_,
            visa_resource_name_query_=visa_resource_name_query_,
            system_name_query_=system_name_query_,
            model_number_query_=model_number_query_,
            vendor_number_query_=vendor_number_query_,
            slot_number_query_=slot_number_query_,
            last_self_calibration_date_query_=last_self_calibration_date_query_,
            last_external_calibration_date_query_=last_external_calibration_date_query_,
            next_recommended_calibration_date_query_=next_recommended_calibration_date_query_,
            last_updated_timestamp_query_=last_updated_timestamp_query_,
            system_connection_query_=system_connection_query_,
            asset_presence_query_=asset_presence_query_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`QueryAssetsFilter` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`QueryAssetsFilter`.
        :rtype: QueryAssetsFilter
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`QueryAssetsFilter` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`QueryAssetsFilter`.
        :rtype: QueryAssetsFilter
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        serial_number_query_ = self.serial_number_query
        if serial_number_query_ is not None:
            serial_number_query_ = serial_number_query_.to_dict()
        model_name_query_ = self.model_name_query
        if model_name_query_ is not None:
            model_name_query_ = model_name_query_.to_dict()
        vendor_name_query_ = self.vendor_name_query
        if vendor_name_query_ is not None:
            vendor_name_query_ = vendor_name_query_.to_dict()
        name_query_ = self.name_query
        if name_query_ is not None:
            name_query_ = name_query_.to_dict()
        firmware_version_query_ = self.firmware_version_query
        if firmware_version_query_ is not None:
            firmware_version_query_ = firmware_version_query_.to_dict()
        hardware_version_query_ = self.hardware_version_query
        if hardware_version_query_ is not None:
            hardware_version_query_ = hardware_version_query_.to_dict()
        visa_resource_name_query_ = self.visa_resource_name_query
        if visa_resource_name_query_ is not None:
            visa_resource_name_query_ = visa_resource_name_query_.to_dict()
        system_name_query_ = self.system_name_query
        if system_name_query_ is not None:
            system_name_query_ = system_name_query_.to_dict()
        model_number_query_ = self.model_number_query
        if model_number_query_ is not None:
            model_number_query_ = model_number_query_.to_dict()
        vendor_number_query_ = self.vendor_number_query
        if vendor_number_query_ is not None:
            vendor_number_query_ = vendor_number_query_.to_dict()
        slot_number_query_ = self.slot_number_query
        if slot_number_query_ is not None:
            slot_number_query_ = slot_number_query_.to_dict()
        last_self_calibration_date_query_ = self.last_self_calibration_date_query  # pylint: disable=invalid-name
        if last_self_calibration_date_query_ is not None:
            last_self_calibration_date_query_ = last_self_calibration_date_query_.to_dict()  # pylint: disable=invalid-name
        last_external_calibration_date_query_ = self.last_external_calibration_date_query  # pylint: disable=invalid-name
        if last_external_calibration_date_query_ is not None:
            last_external_calibration_date_query_ = last_external_calibration_date_query_.to_dict()  # pylint: disable=invalid-name
        next_recommended_calibration_date_query_ = self.next_recommended_calibration_date_query  # pylint: disable=invalid-name
        if next_recommended_calibration_date_query_ is not None:
            next_recommended_calibration_date_query_ = next_recommended_calibration_date_query_.to_dict()  # pylint: disable=invalid-name
        last_updated_timestamp_query_ = self.last_updated_timestamp_query
        if last_updated_timestamp_query_ is not None:
            last_updated_timestamp_query_ = last_updated_timestamp_query_.to_dict()
        system_connection_query_ = self.system_connection_query
        if system_connection_query_ is not None:
            system_connection_query_ = system_connection_query_.to_dict()
        asset_presence_query_ = self.asset_presence_query
        if asset_presence_query_ is not None:
            asset_presence_query_ = asset_presence_query_.to_dict()
        return {
            'SerialNumberQuery': serial_number_query_,
            'ModelNameQuery': model_name_query_,
            'VendorNameQuery': vendor_name_query_,
            'NameQuery': name_query_,
            'FirmwareVersionQuery': firmware_version_query_,
            'HardwareVersionQuery': hardware_version_query_,
            'VisaResourceNameQuery': visa_resource_name_query_,
            'SystemNameQuery': system_name_query_,
            'ModelNumberQuery': model_number_query_,
            'VendorNumberQuery': vendor_number_query_,
            'SlotNumberQuery': slot_number_query_,
            'LastSelfCalibrationDateQuery': last_self_calibration_date_query_,
            'LastExternalCalibrationDateQuery': last_external_calibration_date_query_,
            'NextRecommendedCalibrationDateQuery': next_recommended_calibration_date_query_,
            'LastUpdatedTimestampQuery': last_updated_timestamp_query_,
            'SystemConnectionQuery': system_connection_query_,
            'AssetPresenceQuery': asset_presence_query_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class TemperatureData(object):
    """
    TemperatureData custom data type.
    """
    def __init__(self,
                 name_,
                 reading_):
        """
        :param name_: name
        :type name_: str
        :param reading_: reading
        :type reading_: float
        """
        self.name = name_
        self.reading = reading_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`TemperatureData` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`TemperatureData`.
        :rtype: TemperatureData
        """
        name_ = body_dict.get('name')
        reading_ = body_dict.get('reading')
        return cls(
            name_=name_,
            reading_=reading_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`TemperatureData` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`TemperatureData`.
        :rtype: TemperatureData
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`TemperatureData` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`TemperatureData`.
        :rtype: TemperatureData
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        name_ = self.name
        reading_ = self.reading
        return {
            'name': name_,
            'reading': reading_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class ExternalCalibrationData(object):
    """
    ExternalCalibrationData custom data type.
    """
    def __init__(self,
                 date_,
                 next_recommended_date_,
                 recommended_interval_,
                 is_limited_,
                 supports_limited_,
                 supports_write_,
                 temperature_info_,
                 checksum_,
                 comments_):
        """
        :param date_: date
        :type date_: str
        :param next_recommended_date_: next_recommended_date
        :type next_recommended_date_: str
        :param recommended_interval_: recommended_interval
        :type recommended_interval_: int
        :param is_limited_: is_limited
        :type is_limited_: bool
        :param supports_limited_: supports_limited
        :type supports_limited_: bool
        :param supports_write_: supports_write
        :type supports_write_: bool
        :param temperature_info_: temperature_info
        :type temperature_info_: list(TemperatureData)
        :param checksum_: checksum
        :type checksum_: str
        :param comments_: comments
        :type comments_: str
        """
        self.date = date_
        self.next_recommended_date = next_recommended_date_
        self.recommended_interval = recommended_interval_
        self.is_limited = is_limited_
        self.supports_limited = supports_limited_
        self.supports_write = supports_write_
        self.temperature_info = temperature_info_
        self.checksum = checksum_
        self.comments = comments_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`ExternalCalibrationData` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`ExternalCalibrationData`.
        :rtype: ExternalCalibrationData
        """
        date_ = body_dict.get('date')
        next_recommended_date_ = body_dict.get('nextRecommendedDate')
        recommended_interval_ = body_dict.get('recommendedInterval')
        is_limited_ = body_dict.get('isLimited')
        supports_limited_ = body_dict.get('supportsLimited')
        supports_write_ = body_dict.get('supportsWrite')
        temperature_info_ = body_dict.get('temperatureInfo')
        if temperature_info_ is not None:
            new_list = []
            for item in temperature_info_:
                item = TemperatureData.from_dict(item)
                new_list.append(item)
            temperature_info_ = new_list
        checksum_ = body_dict.get('checksum')
        comments_ = body_dict.get('comments')
        return cls(
            date_=date_,
            next_recommended_date_=next_recommended_date_,
            recommended_interval_=recommended_interval_,
            is_limited_=is_limited_,
            supports_limited_=supports_limited_,
            supports_write_=supports_write_,
            temperature_info_=temperature_info_,
            checksum_=checksum_,
            comments_=comments_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`ExternalCalibrationData` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`ExternalCalibrationData`.
        :rtype: ExternalCalibrationData
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`ExternalCalibrationData` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`ExternalCalibrationData`.
        :rtype: ExternalCalibrationData
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        date_ = self.date
        next_recommended_date_ = self.next_recommended_date
        recommended_interval_ = self.recommended_interval
        is_limited_ = self.is_limited
        supports_limited_ = self.supports_limited
        supports_write_ = self.supports_write
        temperature_info_ = self.temperature_info
        if temperature_info_ is not None:
            new_list = []
            for item in temperature_info_:
                new_list.append(item.to_dict())
            temperature_info_ = new_list
        checksum_ = self.checksum
        comments_ = self.comments
        return {
            'date': date_,
            'nextRecommendedDate': next_recommended_date_,
            'recommendedInterval': recommended_interval_,
            'isLimited': is_limited_,
            'supportsLimited': supports_limited_,
            'supportsWrite': supports_write_,
            'temperatureInfo': temperature_info_,
            'checksum': checksum_,
            'comments': comments_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class SelfCalibrationData(object):
    """
    SelfCalibrationData custom data type.
    """
    def __init__(self,
                 date_,
                 is_limited_,
                 temperature_info_):
        """
        :param date_: date
        :type date_: str
        :param is_limited_: is_limited
        :type is_limited_: bool
        :param temperature_info_: temperature_info
        :type temperature_info_: list(TemperatureData)
        """
        self.date = date_
        self.is_limited = is_limited_
        self.temperature_info = temperature_info_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`SelfCalibrationData` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`SelfCalibrationData`.
        :rtype: SelfCalibrationData
        """
        date_ = body_dict.get('date')
        is_limited_ = body_dict.get('isLimited')
        temperature_info_ = body_dict.get('temperatureInfo')
        if temperature_info_ is not None:
            new_list = []
            for item in temperature_info_:
                item = TemperatureData.from_dict(item)
                new_list.append(item)
            temperature_info_ = new_list
        return cls(
            date_=date_,
            is_limited_=is_limited_,
            temperature_info_=temperature_info_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`SelfCalibrationData` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`SelfCalibrationData`.
        :rtype: SelfCalibrationData
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`SelfCalibrationData` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`SelfCalibrationData`.
        :rtype: SelfCalibrationData
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        date_ = self.date
        is_limited_ = self.is_limited
        temperature_info_ = self.temperature_info
        if temperature_info_ is not None:
            new_list = []
            for item in temperature_info_:
                new_list.append(item.to_dict())
            temperature_info_ = new_list
        return {
            'date': date_,
            'isLimited': is_limited_,
            'temperatureInfo': temperature_info_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AssetData(object):
    """
    AssetData custom data type.
    """
    def __init__(self,
                 resource_uri_,
                 serial_number_,
                 vendor_number_,
                 model_number_,
                 bus_type_,
                 supports_self_calibration_,
                 self_calibration_entry_,
                 supports_external_calibration_,
                 external_calibration_entry_,
                 temperature_info_):
        """
        :param resource_uri_: resource_uri
        :type resource_uri_: str
        :param serial_number_: serial_number
        :type serial_number_: str
        :param vendor_number_: vendor_number
        :type vendor_number_: long
        :param model_number_: model_number
        :type model_number_: long
        :param bus_type_: bus_type
        :type bus_type_: long
        :param supports_self_calibration_: supports_self_calibration
        :type supports_self_calibration_: bool
        :param self_calibration_entry_: self_calibration_entry
        :type self_calibration_entry_: SelfCalibrationData
        :param supports_external_calibration_: supports_external_calibration
        :type supports_external_calibration_: bool
        :param external_calibration_entry_: external_calibration_entry
        :type external_calibration_entry_: ExternalCalibrationData
        :param temperature_info_: temperature_info
        :type temperature_info_: list(TemperatureData)
        """
        self.resource_uri = resource_uri_
        self.serial_number = serial_number_
        self.vendor_number = vendor_number_
        self.model_number = model_number_
        self.bus_type = bus_type_
        self.supports_self_calibration = supports_self_calibration_
        self.self_calibration_entry = self_calibration_entry_
        self.supports_external_calibration = supports_external_calibration_
        self.external_calibration_entry = external_calibration_entry_
        self.temperature_info = temperature_info_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AssetData` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AssetData`.
        :rtype: AssetData
        """
        resource_uri_ = body_dict.get('resourceUri')
        serial_number_ = body_dict.get('serialNumber')
        vendor_number_ = body_dict.get('vendorNumber')
        model_number_ = body_dict.get('modelNumber')
        bus_type_ = body_dict.get('busType')
        supports_self_calibration_ = body_dict.get('supportsSelfCalibration')
        self_calibration_entry_ = body_dict.get('selfCalibrationEntry')
        if self_calibration_entry_ is not None:
            self_calibration_entry_ = SelfCalibrationData.from_dict(self_calibration_entry_)
        supports_external_calibration_ = body_dict.get('supportsExternalCalibration')
        external_calibration_entry_ = body_dict.get('externalCalibrationEntry')
        if external_calibration_entry_ is not None:
            external_calibration_entry_ = ExternalCalibrationData.from_dict(external_calibration_entry_)
        temperature_info_ = body_dict.get('temperatureInfo')
        if temperature_info_ is not None:
            new_list = []
            for item in temperature_info_:
                item = TemperatureData.from_dict(item)
                new_list.append(item)
            temperature_info_ = new_list
        return cls(
            resource_uri_=resource_uri_,
            serial_number_=serial_number_,
            vendor_number_=vendor_number_,
            model_number_=model_number_,
            bus_type_=bus_type_,
            supports_self_calibration_=supports_self_calibration_,
            self_calibration_entry_=self_calibration_entry_,
            supports_external_calibration_=supports_external_calibration_,
            external_calibration_entry_=external_calibration_entry_,
            temperature_info_=temperature_info_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AssetData` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AssetData`.
        :rtype: AssetData
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AssetData` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`AssetData`.
        :rtype: AssetData
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        resource_uri_ = self.resource_uri
        serial_number_ = self.serial_number
        vendor_number_ = self.vendor_number
        model_number_ = self.model_number
        bus_type_ = self.bus_type
        supports_self_calibration_ = self.supports_self_calibration
        self_calibration_entry_ = self.self_calibration_entry
        if self_calibration_entry_ is not None:
            self_calibration_entry_ = self_calibration_entry_.to_dict()
        supports_external_calibration_ = self.supports_external_calibration
        external_calibration_entry_ = self.external_calibration_entry
        if external_calibration_entry_ is not None:
            external_calibration_entry_ = external_calibration_entry_.to_dict()
        temperature_info_ = self.temperature_info
        if temperature_info_ is not None:
            new_list = []
            for item in temperature_info_:
                new_list.append(item.to_dict())
            temperature_info_ = new_list
        return {
            'resourceUri': resource_uri_,
            'serialNumber': serial_number_,
            'vendorNumber': vendor_number_,
            'modelNumber': model_number_,
            'busType': bus_type_,
            'supportsSelfCalibration': supports_self_calibration_,
            'selfCalibrationEntry': self_calibration_entry_,
            'supportsExternalCalibration': supports_external_calibration_,
            'externalCalibrationEntry': external_calibration_entry_,
            'temperatureInfo': temperature_info_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AssetIdentification(object):
    """
    AssetIdentification custom data type.
    """
    def __init__(self,
                 model_name_,
                 model_number_,
                 serial_number_,
                 vendor_name_,
                 vendor_number_,
                 bus_type_):
        """
        :param model_name_: model_name
        :type model_name_: str
        :param model_number_: model_number
        :type model_number_: long
        :param serial_number_: serial_number
        :type serial_number_: str
        :param vendor_name_: vendor_name
        :type vendor_name_: str
        :param vendor_number_: vendor_number
        :type vendor_number_: long
        :param bus_type_: bus_type
        :type bus_type_: str
        """
        self.model_name = model_name_
        self.model_number = model_number_
        self.serial_number = serial_number_
        self.vendor_name = vendor_name_
        self.vendor_number = vendor_number_
        self.bus_type = bus_type_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AssetIdentification` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AssetIdentification`.
        :rtype: AssetIdentification
        """
        model_name_ = body_dict.get('modelName')
        model_number_ = body_dict.get('modelNumber')
        serial_number_ = body_dict.get('serialNumber')
        vendor_name_ = body_dict.get('vendorName')
        vendor_number_ = body_dict.get('vendorNumber')
        bus_type_ = body_dict.get('busType')
        return cls(
            model_name_=model_name_,
            model_number_=model_number_,
            serial_number_=serial_number_,
            vendor_name_=vendor_name_,
            vendor_number_=vendor_number_,
            bus_type_=bus_type_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AssetIdentification` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AssetIdentification`.
        :rtype: AssetIdentification
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AssetIdentification` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`AssetIdentification`.
        :rtype: AssetIdentification
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        model_name_ = self.model_name
        model_number_ = self.model_number
        serial_number_ = self.serial_number
        vendor_name_ = self.vendor_name
        vendor_number_ = self.vendor_number
        bus_type_ = self.bus_type
        return {
            'modelName': model_name_,
            'modelNumber': model_number_,
            'serialNumber': serial_number_,
            'vendorName': vendor_name_,
            'vendorNumber': vendor_number_,
            'busType': bus_type_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class Property(object):
    """
    Property custom data type.
    """
    def __init__(self,
                 key_,
                 value_):
        """
        :param key_: key
        :type key_: str
        :param value_: value
        :type value_: str
        """
        self.key = key_
        self.value = value_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`Property` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`Property`.
        :rtype: Property
        """
        key_ = body_dict.get('key')
        value_ = body_dict.get('value')
        return cls(
            key_=key_,
            value_=value_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`Property` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`Property`.
        :rtype: Property
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`Property` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`Property`.
        :rtype: Property
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        key_ = self.key
        value_ = self.value
        return {
            'key': key_,
            'value': value_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


class AssetUpdateProperties(object):
    """
    AssetUpdateProperties custom data type.
    """
    def __init__(self,
                 asset_identification_,
                 properties_):
        """
        :param asset_identification_: asset_identification
        :type asset_identification_: AssetIdentification
        :param properties_: properties
        :type properties_: list(Property)
        """
        self.asset_identification = asset_identification_
        self.properties = properties_

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AssetUpdateProperties` using a dictionary.

        :param body_dict: A dictionary representing the body.
        :type body_dict: dict
        :return: A new instance of :class:`AssetUpdateProperties`.
        :rtype: AssetUpdateProperties
        """
        asset_identification_ = body_dict.get('assetIdentification')
        if asset_identification_ is not None:
            asset_identification_ = AssetIdentification.from_dict(asset_identification_)
        properties_ = body_dict.get('properties')
        if properties_ is not None:
            new_list = []
            for item in properties_:
                item = Property.from_dict(item)
                new_list.append(item)
            properties_ = new_list
        return cls(
            asset_identification_=asset_identification_,
            properties_=properties_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AssetUpdateProperties` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AssetUpdateProperties`.
        :rtype: AssetUpdateProperties
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AssetUpdateProperties` using a body
        of type :class:`bytes` or :class:`bytearray`.

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`AssetUpdateProperties`.
        :rtype: AssetUpdateProperties
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        asset_identification_ = self.asset_identification
        if asset_identification_ is not None:
            asset_identification_ = asset_identification_.to_dict()
        properties_ = self.properties
        if properties_ is not None:
            new_list = []
            for item in properties_:
                new_list.append(item.to_dict())
            properties_ = new_list
        return {
            'assetIdentification': asset_identification_,
            'properties': properties_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')


#
# AssetPerformanceManagement service
#


class AssetPerformanceManagementMinionCalibrationUpdatedBroadcast(BroadcastMessage):
    """
    AssetPerformanceManagementMinionCalibrationUpdatedBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'AssetPerformanceManagementMinionCalibrationUpdatedBroadcast'

    def __init__(self,
                 minion_id_,
                 assets_,
                 message_version_):
        """
        :param minion_id_: minion_id
        :type minion_id_: str
        :param assets_: assets
        :type assets_: list(AssetData)
        :param message_version_: message_version
        :type message_version_: int
        """
        self.minion_id = minion_id_
        self.assets = assets_
        self.message_version = message_version_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(AssetPerformanceManagementMinionCalibrationUpdatedBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AssetPerformanceManagementMinionCalibrationUpdatedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AssetPerformanceManagementMinionCalibrationUpdatedBroadcast`.
        :rtype: AssetPerformanceManagementMinionCalibrationUpdatedBroadcast
        """
        minion_id_ = body_dict.get('minionId')
        assets_ = body_dict.get('assets')
        if assets_ is not None:
            new_list = []
            for item in assets_:
                item = AssetData.from_dict(item)
                new_list.append(item)
            assets_ = new_list
        message_version_ = body_dict.get('messageVersion')
        return cls(
            minion_id_=minion_id_,
            assets_=assets_,
            message_version_=message_version_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AssetPerformanceManagementMinionCalibrationUpdatedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AssetPerformanceManagementMinionCalibrationUpdatedBroadcast`.
        :rtype: AssetPerformanceManagementMinionCalibrationUpdatedBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AssetPerformanceManagementMinionCalibrationUpdatedBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`AssetPerformanceManagementMinionCalibrationUpdatedBroadcast`.
        :rtype: AssetPerformanceManagementMinionCalibrationUpdatedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AssetPerformanceManagementMinionCalibrationUpdatedBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`AssetPerformanceManagementMinionCalibrationUpdatedBroadcast`.
        :rtype: AssetPerformanceManagementMinionCalibrationUpdatedBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        minion_id_ = self.minion_id
        assets_ = self.assets
        if assets_ is not None:
            new_list = []
            for item in assets_:
                new_list.append(item.to_dict())
            assets_ = new_list
        message_version_ = self.message_version
        return {
            'minionId': minion_id_,
            'assets': assets_,
            'messageVersion': message_version_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body


class AssetPerformanceManagementMinionAssetsUpdatedBroadcast(BroadcastMessage):
    """
    AssetPerformanceManagementMinionAssetsUpdatedBroadcast JSON broadcast message.
    """
    MESSAGE_NAME = 'AssetPerformanceManagementMinionAssetsUpdatedBroadcast'

    def __init__(self,
                 message_version_,
                 minion_id_,
                 assets_):
        """
        :param message_version_: message_version
        :type message_version_: int
        :param minion_id_: minion_id
        :type minion_id_: str
        :param assets_: assets
        :type assets_: list(AssetUpdateProperties)
        """
        self.message_version = message_version_
        self.minion_id = minion_id_
        self.assets = assets_
        header = MessageHeader()
        header.message_name = self.MESSAGE_NAME
        header.content_type = JSON_MESSAGE_CONTENT_TYPE
        routing_key = MessageHeader.generate_routing_key(None, self.MESSAGE_NAME)
        header.routing_key = routing_key
        super(AssetPerformanceManagementMinionAssetsUpdatedBroadcast, self).__init__(header, None)

    @classmethod
    def from_dict(cls, body_dict):
        """
        Create a new instance of :class:`AssetPerformanceManagementMinionAssetsUpdatedBroadcast` using a dictionary.

        :param body_dict: The body as a dictionary.
        :type body_dict: dict
        :return: A new instance of :class:`AssetPerformanceManagementMinionAssetsUpdatedBroadcast`.
        :rtype: AssetPerformanceManagementMinionAssetsUpdatedBroadcast
        """
        message_version_ = body_dict.get('messageVersion')
        minion_id_ = body_dict.get('minionId')
        assets_ = body_dict.get('assets')
        if assets_ is not None:
            new_list = []
            for item in assets_:
                item = AssetUpdateProperties.from_dict(item)
                new_list.append(item)
            assets_ = new_list
        return cls(
            message_version_=message_version_,
            minion_id_=minion_id_,
            assets_=assets_
        )

    @classmethod
    def from_json(cls, body_json):
        """
        Create a new instance of :class:`AssetPerformanceManagementMinionAssetsUpdatedBroadcast` using a JSON string.

        :param body_json: A string in JSON format representing the body.
        :type body_json: str
        :return: A new instance of :class:`AssetPerformanceManagementMinionAssetsUpdatedBroadcast`.
        :rtype: AssetPerformanceManagementMinionAssetsUpdatedBroadcast
        """
        body_dict = json.loads(body_json)
        return cls.from_dict(body_dict)

    @classmethod
    def from_body_bytes(cls, body_bytes):
        """
        Create a new instance of :class:`AssetPerformanceManagementMinionAssetsUpdatedBroadcast` using a body
        of type :class:`bytes` or :class:`bytearray`,

        :param body_bytes: The body to use.
        :type body_bytes: bytes or bytearray
        :return: A new instance of :class:`AssetPerformanceManagementMinionAssetsUpdatedBroadcast`.
        :rtype: AssetPerformanceManagementMinionAssetsUpdatedBroadcast
        """
        body_json = str(body_bytes, 'utf-8')
        return cls.from_json(body_json)

    @classmethod
    def from_message(cls, message):
        """
        Create a new instance of :class`AssetPerformanceManagementMinionAssetsUpdatedBroadcast` using a
        :class:`systemlink.messagebus.message_base.MessageBase` derived message.

        :param message: The message to use as the basis for this class instance.
        :type message: systemlink.messagebus.message_base.MessageBase
        :return: A new instance of :class`AssetPerformanceManagementMinionAssetsUpdatedBroadcast`.
        :rtype: AssetPerformanceManagementMinionAssetsUpdatedBroadcast
        """
        instance = cls.from_body_bytes(message.body_bytes)
        instance.correlation_id = message.correlation_id
        instance.reply_to = message.reply_to
        return instance

    def to_dict(self):
        """
        Returns a dictionary representing the data in this object.

        :return: A dictionary representing the data in this object.
        :rtype: dict
        """
        message_version_ = self.message_version
        minion_id_ = self.minion_id
        assets_ = self.assets
        if assets_ is not None:
            new_list = []
            for item in assets_:
                new_list.append(item.to_dict())
            assets_ = new_list
        return {
            'messageVersion': message_version_,
            'minionId': minion_id_,
            'assets': assets_
        }

    def to_json(self):
        """
        Returns a JSON string representing the data in this object.

        :return: A JSON string representing the data in this object.
        :rtype: str
        """
        body_dict = self.to_dict()
        return json.dumps(body_dict, separators=(',', ':'))

    def to_body_bytes(self):
        """
        Returns a :class:`bytearray` body representing the data in this object.

        :return: A :class:`bytearray` body representing the data in this object.
        :rtype: bytearray
        """
        body_json = self.to_json()
        return bytearray(body_json, 'utf-8')

    def to_message(self, request_message=None):
        """
        Returns a :class:`systemlink.messagebus.message_base.MessageBase`
        object representing the data in this object.

        :param request_message: Request message if this is a response.
        :type request_message: systemlink.messagebus.message_base.MessageBase or None
        :return: A :class:`systemlink.messagebus.message_base.MessageBase`
            object representing the data in this object.
        :rtype: systemlink.messagebus.message_base.MessageBase
        """
        header = self.header
        if request_message:
            request_header = request_message.header
            header.correlation_id = request_header.correlation_id
        body_bytes = self.to_body_bytes()
        return MessageBase(header, body_bytes)

    @property
    def body_bytes(self):
        """
        Returns a :class:`bytes` body representing the data in this object.

        :return: A :class:`bytes` body representing the data in this object.
        :rtype: bytes
        """
        self._body = self.to_body_bytes()  # pylint: disable=attribute-defined-outside-init
        return self._body
